﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;


namespace WinApp_WinGrid_CustomSummaryCalculator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();  
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.UseAppStyling = true;

            System.Diagnostics.Debug.WriteLine("Form1_Load");

             if(ultraGrid1.DataSource == null)
             {
                 try
                 {   
                     ultraGrid1.DataSource = MakeOrdersDataTable();
                 }
                 catch (Exception myException)
                 {
                     System.Diagnostics.Debug.WriteLine(myException);
                 }
                 finally {
                 
                 }
             }
        }       

        private DataTable MakeOrdersDataTable()
        {
            System.Diagnostics.Debug.WriteLine("MakeOrdersDataTable");

            // Declare a DataTable to contain the program generated data
            DataTable dataTable = new DataTable("Orders");

            //Create and add a CustomerID column
            DataColumn colWork = new DataColumn("CustomerID", System.Type.GetType("System.Int32"));
            dataTable.Columns.Add(colWork);

            // Add CustomerID column to key array
            DataColumn[] Keys = new DataColumn[2];
            Keys[0] = colWork; 

            // Create and add OrderID column
            colWork = new DataColumn("OrderID", System.Type.GetType("System.Int32"));
            //colWork.MaxLength = 15;
            dataTable.Columns.Add(colWork);

            // Add OrderID column to key array and bind to DataTable           
            Keys[1] = colWork;
            dataTable.PrimaryKey = Keys;

            // Add OrderID column to key array and bind to DataTable
            //Keys[1] = colWork;
            dataTable.PrimaryKey = Keys;

            //// Create and add a EmployeeID column
            //colWork = new DataColumn("EmployeeID", System.Type.GetType("System.Int32"));
            //dataTable.Columns.Add(colWork);

            // Create and add a OrderDate column
            colWork = new DataColumn("OrderDate", System.Type.GetType("System.DateTime"));
            dataTable.Columns.Add(colWork);

            // Create and add a ShipDate column
            colWork = new DataColumn("ShipDate", System.Type.GetType("System.DateTime"));
            dataTable.Columns.Add(colWork);

            // Create and add a ShipCost column
            colWork = new DataColumn("ShipCost", System.Type.GetType("System.Double"));
            dataTable.Columns.Add(colWork);

            //// Create and add a ShipDate column
            //colWork = new DataColumn("ShipAddress", System.Type.GetType("System.String"));
            //dataTable.Columns.Add(colWork);

            // Create and add a EmployeeID column
            colWork = new DataColumn("ProductID", System.Type.GetType("System.Int32"));
            dataTable.Columns.Add(colWork);

            // Create and add a OrderDate column
            colWork = new DataColumn("ProductName", System.Type.GetType("System.String"));
            dataTable.Columns.Add(colWork);

            // Create and add a ShipDate column
            colWork = new DataColumn("UnitQty", System.Type.GetType("System.Int32"));
            dataTable.Columns.Add(colWork);

            // Create and add a ShipDate column
            colWork = new DataColumn("UnitCost", System.Type.GetType("System.Double"));
            dataTable.Columns.Add(colWork);

            // Add Multiple Customers with Order rows
            for (Int32 intCust = 1; intCust <= 2; intCust++)
            {
                // Add rows for each Customer
                DataRow row;
                for (Int32 intPtr = 1; intPtr <= 6; intPtr++)
                {
                    row = dataTable.NewRow();
                    row["CustomerID"] = intCust;
                    row["OrderID"] = (intPtr * intPtr )+ 3;
                    //row["EmployeeID"] = intPtr * 10;
                    row["OrderDate"] = System.DateTime.Now.AddDays(intPtr);
                    row["ShipDate"] = System.DateTime.Now.AddDays(intPtr + 2);
                    row["ShipCost"] = intPtr * 1.35;

                    row["ProductID"] = intPtr;
                    switch (intPtr)
                    {
                        case 1:
                            row["ProductName"] = "Waders";
                            row["UnitQty"] = 1;
                            row["UnitCost"] = 52.99;
                            break;
                        case 2:
                        case 5:
                            row["ProductName"] = "Jeans";
                            row["UnitQty"] = 2;
                            row["UnitCost"] = 25.99;
                            break;
                        case 3: 
                        case 6:
                            row["ProductName"] = "T-Shirt";
                            row["UnitQty"] = 2;
                            row["UnitCost"] = 12.99;
                            break;
                        case 4:
                            row["ProductName"] = "Belt";
                            row["UnitQty"] = 1;
                            row["UnitCost"] = 25.39;
                            break;
                        default:
                            row["ProductName"] = "";
                            row["UnitQty"] = 0;
                            row["UnitCost"] = 0;
                            break;
                    }
                    dataTable.Rows.Add(row);
                }
            }            
            return dataTable;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //System.Diagnostics.Debug.WriteLine("ultraGrid1_InitializeLayout");

            System.Diagnostics.Debug.WriteLine("ultraGrid1_InitializeLayout");
                    
            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;

            this.ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            e.Layout.Bands[0].GroupHeadersVisible = true;
            e.Layout.Bands[0].IndentationGroupByRowExpansionIndicator = 1;
            e.Layout.Bands[0].IndentationGroupByRow= 3;

            e.Layout.Bands[0].Override.AllowRowSummaries = AllowRowSummaries.True;
            // Cause Grand Total summary when use 
            //e.Layout.Bands[0].Override.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows 
            //   OR  SummaryDisplayAreas.TopFixed;
            e.Layout.Bands[0].Override.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows;            
            //e.Layout.Bands[0].Override.SummaryDisplayArea = SummaryDisplayAreas.TopFixed;
            //e.Layout.Bands[0].Override.SummaryDisplayArea = SummaryDisplayAreas.GroupByRowsFooter;

            //e.Layout.Bands[0].Override.GroupBySummaryDisplayStyle = GroupBySummaryDisplayStyle.SummaryCellsAlwaysBelowDescription;
            e.Layout.Bands[0].Override.GroupBySummaryDisplayStyle = GroupBySummaryDisplayStyle.Default;
            e.Layout.Bands[0].Override.GroupBySummaryValueAppearance.BackColor = System.Drawing.Color.LightBlue;

            e.Layout.Bands[0].SortedColumns.Add("CustomerID", false, true);
            e.Layout.Bands[0].SortedColumns.Add("OrderID", false, true);
            //e.Layout.Bands[0].SortedColumns.Add("ProductID", false, true);
           
            e.Layout.Bands[0].Columns["CustomerID"].AllowGroupBy= DefaultableBoolean.True;
            e.Layout.Bands[0].Columns["OrderDate"].AllowGroupBy = DefaultableBoolean.True;

            //e.Layout.Bands[0].Columns["CustomerID"].GroupByMode = GroupByMode.Value;
            //e.Layout.Bands[0].Columns["OrderDate"].GroupByMode = GroupByMode.Date;

            //this.ultraGrid1.DisplayLayout.Override.AllowAddNew = AllowAddNew.Yes;
            e.Layout.Override.AllowAddNew = AllowAddNew.FixedAddRowOnBottom;
            e.Layout.Override.TemplateAddRowPrompt = "Click here to add rows...";           

            // Set the AllowRowSummaries to either True or BasedOnDataType to allow
            // the user to be able to add, remove or modify summaries. This is not
            // necessary to create summaries programmatically and only effects the
            //users ability to create, remove or modify summaries
            e.Layout.Bands[0].Override.AllowRowSummaries= AllowRowSummaries.BasedOnDataType;

            // You can also prevent the user from adding, removing or modifying a
            // summary on a column basis. Prevent the user from summarizing OrderID
            // column.
            e.Layout.Bands[0].Columns["CustomerID"].AllowRowSummaries = AllowRowSummaries.False;
            //e.Layout.Bands[0].Columns["OrderID"].AllowRowSummaries = AllowRowSummaries.False;
            //e.Layout.Bands[0].Columns["ProductID"].AllowRowSummaries = AllowRowSummaries.False;
           
           // Add summaries. Notice the keys "Max" and "Avg". We will use them to
           // identify the summaries later on for example in SummaryValueChanged
           // event.
           SummarySettings maxSummary = e.Layout.Bands[0].Summaries.Add( "Max", SummaryType.Maximum, e.Layout.Bands[0].Columns["UnitQty"] );
           SummarySettings avgSummary = e.Layout.Bands[0].Summaries.Add( "Avg", SummaryType.Average, e.Layout.Bands[0].Columns["UnitCost"] );

           // Set the format of the summary text
           maxSummary.DisplayFormat = "Min = {0:#####.00}";
           avgSummary.DisplayFormat = "Avg = {0:#####.00}";

           // Change the appearance settings for summaries.
           maxSummary.Appearance.TextHAlign = HAlign.Right;
           avgSummary.Appearance.TextHAlign = HAlign.Right;            

           // Set the DisplayInGroupBy property of both summaries to false so they don't
           // show up in group-by rows.
           maxSummary.SummaryDisplayArea = SummaryDisplayAreas.Default;
           avgSummary.SummaryDisplayArea = SummaryDisplayAreas.Default; 

           // Set the caption that shows up on the header of the summary footer.
           e.Layout.Bands[0].SummaryFooterCaption = "Summary of Unit Price times Qty";
           e.Layout.Bands[0].Override.SummaryFooterCaptionAppearance.FontData.Bold = DefaultableBoolean.True;
           e.Layout.Bands[0].Override.SummaryFooterCaptionAppearance.BackColor = Color.DarkBlue;
           e.Layout.Bands[0].Override.SummaryFooterCaptionAppearance.ForeColor = Color.LightYellow;

          // e.Layout.Bands[0].ColHeadersVisible = false;

           //Infragistics.Win.UltraWinCalcManager.UltraCalcManager calcManager;
           //calcManager = new Infragistics.Win.UltraWinCalcManager.UltraCalcManager(this.Container);
           //e.Layout.Grid.CalcManager = calcManager;

           //e.Layout.Grid.CalcManager = this.ultraCalcManager1;
            
           SummarySettings ssOrderID = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(
                "orderSummary",             // Give an identifier (key) for this summary
                SummaryType.Custom,         // Summary type is custom
                new SummaryCalculator(),    // Our custom summary calculator
                this.ultraGrid1.DisplayLayout.Bands[0].Columns["UnitCost"],  // Column being summarized. Just use Unit Price column.
                SummaryPosition.UseSummaryPositionColumn,                   // Position the summary on the left of summary footer
                this.ultraGrid1.DisplayLayout.Bands[0].Columns["OrderDate"]); // Since SummaryPosition is Left, pass in null   
            ssOrderID.DisplayFormat = "Sum=${0}";

            SummarySettings ssShipDate = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(
                "ShipDateSummary",             // Give an identifier (key) for this summary
                SummaryType.Custom,         // Summary type is custom               
                new TotalCustomCalculator(), // Our custom summary calculator              
                this.ultraGrid1.DisplayLayout.Bands[0].Columns["ShipDate"],  // Column being summarized. Just use Unit Price column.
                SummaryPosition.Left,       // Position the summary on the left of summary footer
                null);                     // Since SummaryPosition is Left, pass in null                 
            ssShipDate.DisplayFormat = "Item Count={0}";

            SummarySettings ssGrandTotal = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(
                "GrandTotalSummary",              // Give an identifier (key) for this summary
                SummaryType.Custom,             // Summary type is custom
                new GrandTotalCustomCalculator(), // Our custom summary calculator
                this.ultraGrid1.DisplayLayout.Bands[0].Columns["ShipDate"],  // Column being summarized. Just use Unit Price column.
                SummaryPosition.Left,            // Position the summary on the left of summary footer
                null);                          // Since SummaryPosition is Left, pass in null               
            ssGrandTotal.DisplayFormat = "Grand Total Count={0}";

            SummarySettings summarySettings1 = new SummarySettings("S0", SummaryType.Formula, "sum( [UnitPrice] )", null, -1, false, null, -1, SummaryPosition.UseSummaryPositionColumn, "UnitPrice", 2, true);
            summarySettings1.DisplayFormat = "Total Items Sold = {0}";
            summarySettings1.Key = "S0";
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries.AddRange(new Infragistics.Win.UltraWinGrid.SummarySettings[] {summarySettings1} );																								
						
            //this.ultraGrid1.DisplayLayout.Bands[0].Summaries.AddRange(new Infragistics.Win.UltraWinGrid.SummarySettings[] {
            //                                                                                          summarySettings1,
            //                                                                                          summarySettings2,
            //                                                                                          summarySettings3,
            //    
        }

        public class SummaryCalculator : ICustomSummaryCalculator
        {
            private double total = 0;
           
            public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("SummaryCalculator AggregateCustomSummary");
                Debug.WriteLine(string.Format("OrderID: {0}", row.Cells["OrderID"].Value.ToString()));

                string cellValue = row.Cells[settings.SourceColumn].Text;
                string cellQty = row.Cells["UnitQty"].Text;
                double val = 0;
                int qty = 0;
              
                // Show UnitPrice * Quantity in summary
                if (double.TryParse(cellValue, out val) && int.TryParse(cellQty, out qty))
                    this.total += (val * qty);
              
                Debug.Unindent();
            }

            public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("SummaryCalculator BeginCustomSummary");
                Debug.WriteLine(string.Format("Row count: {0}", rows.Count.ToString()));
                if (rows[0].IsGroupByRow)
                {
                    Debug.WriteLine("GroupByRow collection");
                }
                else
                {
                    Debug.WriteLine("UltraGridRow collection");
                }
                this.total = 0;
                Debug.Unindent();
            }

            public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("SummaryCalculator EndCustomSummary");
                Debug.Unindent();
                return this.total;
            }
        }

        public class TotalCustomCalculator : ICustomSummaryCalculator
        {
            private double total = 0;
            private string SummaryName = "";
            public void New(String summaryName)
            {
                SummaryName = summaryName;
            }

            public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("TotalCustomCalculator AggregateCustomSummary");
                Debug.WriteLine(string.Format("OrderID: {0}", row.Cells["OrderID"].Value.ToString()));

                //string cellValue = row.Cells[settings.SourceColumn].Text;                
                string cellQty = row.Cells["UnitQty"].Text;
                Int32 val = 0;                
                if (Int32.TryParse(cellQty, out val))
                    this.total += val;
              
                Debug.Unindent();
            }

            public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("TotalCustomCalculator BeginCustomSummary");
                Debug.WriteLine(string.Format("Row count: {0}", rows.Count.ToString()));
                if (rows[0].IsGroupByRow)
                {
                    Debug.WriteLine("GroupByRow collection");
                }
                else
                {
                    Debug.WriteLine("UltraGridRow collection");
                }
                this.total = 0;
                Debug.Unindent();
            }

            public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                Debug.WriteLine("------------------------------------------------------------------------");
                Debug.Indent();
                Debug.WriteLine("TotalCustomCalculator EndCustomSummary");
                
                //SummaryValuesCollection smValuesCol = rows.SummaryValues;
                //Decimal sumValue  = Convert.ToDecimal(rows.SummaryValues.GetSummaryValueFromPosition(SummaryPosition.UseSummaryPositionColumn), this.SummaryName),0);
                //Decimal fteValue = sumValue / Convert.ToInt32(rows(0).GetCellValeu("HoursInMonth"));
                //return fteValue;
                
                Debug.Unindent();
                return this.total;
            }

        }

        public class GrandTotalCustomCalculator : ICustomSummaryCalculator
        {
            private double total = 0;

            public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
            {
                //string cellValue = row.Cells[settings.SourceColumn].Text;                
                string cellQty = row.Cells["UnitQty"].Text;
                Int32 val = 0;
                if (Int32.TryParse(cellQty, out val))
                    this.total += val;
            }

            public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                this.total = 0;
            }

            public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                return this.total;
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {

            System.Diagnostics.Debug.WriteLine("ultraGrid1_InitializeLayout");       

            UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands[0];

            // Add a summary.
            SummarySettings summary = band.Summaries.Add(SummaryType.Count, band.Columns["OrderID"]);

            // Set the summary position to Left so that it shows up on the left of the
            // summary footer area.
            summary.SummaryPosition = SummaryPosition.Left;

            // Set the format with which to format the calculated summary when displaying
            // in the summary footer.
            summary.DisplayFormat = "Record Count = {0:#####}";

            // Set the appearance of the summary.
            summary.Appearance.TextHAlign = HAlign.Left;
            summary.Appearance.ForeColor = Color.DarkBlue;
            summary.Appearance.BackColor = Color.White;

            // Set the border style of summaries to desired value.
            band.Override.BorderStyleSummaryValue = UIElementBorderStyle.None;

            // Set the appearance of summary footer and the footer caption.
            band.Override.SummaryFooterAppearance.BackColor = Color.White;
            band.Override.SummaryFooterCaptionAppearance.BackColor = Color.White;

            // Set the text that shows up in the caption of the summary footer.
            // You can use column names in square brackets like [CustomerID] below.
            band.SummaryFooterCaption = "Summary: [OrderID]";
           
        }

        private void ultraGrid1_InitializeGroupByRow(object sender, InitializeGroupByRowEventArgs e)
        {
            // ReInitialize indicates whether the row is being initialized for the first time
            // or it's being re-initialized.
            if (e.ReInitialize)
                Debug.WriteLine("A group-by row is being re-initilaized.");
            else
                Debug.WriteLine("A group-by row is being initilaized.");

            // Set the description to desired value. This is the text that shows up on
            // the group-by row.
            e.Row.Description = e.Row.Value.ToString() + ", " + e.Row.Rows.Count + " Items.";

            // We only want to do this if we are grouping by the Country column.
            if (e.Row.Column.Key == "CustomerID")
            {
                // If the group has more than 5 items, then make the background color
                // of the row to red
                if (e.Row.Rows.Count > 10)
                {
                    e.Row.Appearance.BackColor = Color.Red;
                }
                else
                {
                    e.Row.Appearance.ResetBackColor();
                }
            }
        }    
    }
}
